//this source code was auto-generated by tolua#, do not modify it
using System;
using System.Collections.Generic;
using LuaInterface;
using AssetPipeline;
using UnityEngine;

public class CLASSTAG_UtilsWrap
{
    public static void Register(LuaState L)
    {
        L.BeginClass(typeof(Utils), typeof(System.Object));
        L.RegFunction("ByteToString",FUNCTAG_ByteToString);
        L.RegFunction("StringToByte",FUNCTAG_StringToByte);
        L.RegFunction("LoadProto",FUNCTAG_LoadProto);
        L.RegFunction("IsObjectExist",FUNCTAG_IsObjectExist);
        L.RegFunction("ShowLuaObjectInfo",FUNCTAG_ShowLuaObjectInfo);
        L.RegFunction("HideGameLoading",FUNCTAG_HideGameLoading);
        L.RegFunction("GetNetworkType",FUNCTAG_GetNetworkType);
        L.RegFunction("GetWifiSignal",FUNCTAG_GetWifiSignal);
        L.RegFunction("GetBatteryLevel",FUNCTAG_GetBatteryLevel);
        L.RegFunction("IsBattleCharging",FUNCTAG_IsBattleCharging);
        L.RegFunction("NewGuid",FUNCTAG_NewGuid);
        L.RegFunction("GetDeviceUID",FUNCTAG_GetDeviceUID);
        L.RegFunction("FindShader",FUNCTAG_FindShader);
        L.RegFunction("SetWindowTitle",FUNCTAG_SetWindowTitle);
        L.RegFunction("GetAppVersion",FUNCTAG_GetAppVersion);
        L.RegFunction("GetResVersion",FUNCTAG_GetResVersion);
        L.RegFunction("GetPackageResVersion",FUNCTAG_GetPackageResVersion);
        L.RegFunction("SetClipBoardText",FUNCTAG_SetClipBoardText);
        L.RegFunction("GetClipBoardText",FUNCTAG_GetClipBoardText);
        L.RegFunction("ReleaseCSharpObjects",FUNCTAG_ReleaseCSharpObjects);
        L.RegFunction("SetGlobalEventHanlder",FUNCTAG_SetGlobalEventHanlder);
        L.RegFunction("SetLogLevel",FUNCTAG_SetLogLevel);
        L.RegFunction("DumpLuaDataFile",FUNCTAG_DumpLuaDataFile);
        L.RegFunction("Vibrate",FUNCTAG_Vibrate);
        L.RegFunction("LogError",FUNCTAG_LogError);
		L.RegFunction("LogLuaError",FUNCTAG_LogLuaError);
		L.RegFunction("LogLuaException",FUNCTAG_LogLuaException);
		L.RegFunction("GetCenterServerUrl",FUNCTAG_GetCenterServerUrl);
		L.RegFunction("SetTcpParerXorKey",FUNCTAG_SetTcpParerXorKey);
		L.RegFunction("GetUpdateMode",FUNCTAG_GetUpdateMode);
        L.RegFunction("SetSoftInputShowCallback",FUNCTAG_SetSoftInputShowCallback);
        L.RegFunction("SetSoftInputHideCallback",FUNCTAG_SetSoftInputHideCallback);
		L.RegFunction("RenderAddMat",FUNCTAG_RenderAddMat);
		L.RegFunction("RenderResizeMatCnt",FUNCTAG_RenderResizeMatCnt);
		L.RegFunction("GetMaterials",FUNCTAG_GetMaterials);
		L.RegFunction("GetGameSettingText",FUNCTAG_GetGameSettingText);
		L.RegFunction("RestoreGameRes",FUNCTAG_RestoreGameRes);
        L.RegFunction("SetCrashAppVersion",FUNCTAG_SetCrashAppVersion);
        L.RegFunction("__tostring",ToLua.op_ToString);
        L.EndClass();
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_StringToByte(IntPtr L)
    {
        try
        {
            ToLua.CheckArgsCount(L, 1);
            byte[] data = LuaDLL.lua_tobytearray(L, 1);
            ToLua.Push(L, data);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_ByteToString(IntPtr L)
    {
        try
        {
            ToLua.CheckArgsCount(L, 1);
            byte[] array = ToLua.CheckByteBuffer(L, 1);
            LuaDLL.lua_pushlstring(L, array, array.Length);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_LoadProto(IntPtr L)
    {
        try
        {
            ToLua.CheckArgsCount(L, 1);
            string file = ToLua.CheckString(L, 1);
            byte[] array = LuaFileUtils.Instance.ReadProto(file);
            ToLua.PushByteBuffer(L, array);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_IsObjectExist(IntPtr L)
    {
        try
        {
            int udata = LuaDLL.tolua_rawnetobj(L, 1);
            ObjectTranslator translator = ObjectTranslator.Get(L);
            object obj = translator.GetObject(udata);
            if (obj == null || obj.Equals(null))
            {
                ToLua.Push(L, false);
            }
            else
            {
                ToLua.Push(L, true);
            }
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }


    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_ShowLuaObjectInfo(IntPtr L)
    {
        try
        {
            ObjectTranslator translator = ObjectTranslator.Get(L);
            UnityEngine.Debug.Log("objectsBackMap  count " + translator.objectsBackMap.Count);
            UnityEngine.Debug.Log("LuaObjectPool count  " + translator.objects.GetCount());
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_HideGameLoading(IntPtr L)
    {
        try
        {
            if (GameLauncher.Instance != null)
            {
                GameLauncher.Instance.DestroyGameLoader();
            }
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_GetNetworkType(IntPtr L)
    {
        try
        {
            string type = PlatformAPI.getNetworkType();
            ToLua.Push(L, type);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }


    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_GetWifiSignal(IntPtr L)
    {
        try
        {
            int value = PlatformAPI.getWifiSignal();
            ToLua.Push(L, value);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_GetBatteryLevel(IntPtr L)
    {
        try
        {
            int value = PlatformAPI.GetBatteryLevel();
            ToLua.Push(L, value);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }


    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_IsBattleCharging(IntPtr L)
    {
        try
        {
            bool value = PlatformAPI.IsBattleCharging();
            ToLua.Push(L, value);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_NewGuid(IntPtr L)
    {
        try
        {
            ToLua.Push(L, System.Guid.NewGuid().ToString());
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_GetDeviceUID(IntPtr L)
    {
        try
        {
            string uid = PlatformAPI.GetDeviceUID();
            ToLua.Push(L, uid);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_FindShader(IntPtr L)
    {
        try
        {
            string name = ToLua.CheckString(L, 1);
            Shader shader = CLASSTAG_ShaderHelper.Find(name);
            ToLua.Push(L, shader);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_SetWindowTitle(IntPtr L)
    {
        try
        {
            string name = ToLua.CheckString(L, 1);
#if UNITY_STANDALONE_WIN
            CLASSTAG_WinAPI.FUNCTAG_SetWindowTitle(name);
#endif
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_GetAppVersion(IntPtr L)
    {
        try
        {
            string version = Application.version;
            string[] vers = version.Split('.');
            for (int i = 0; i < vers.Length; i++)
            {
                ToLua.Push(L, int.Parse(vers[i]));
            }
            return vers.Length;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_GetPackageResVersion(IntPtr L)
    {
        try
        {
            ToLua.Push(L, CLASSTAG_GameVersion.frameworkVersion);
            ToLua.Push(L, CLASSTAG_GameVersion.packageDllVersion);
            ToLua.Push(L, CLASSTAG_GameVersion.packageResVersion);
            ToLua.Push(L, CLASSTAG_GameVersion.packageSvnVersion);
            return 4;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_GetResVersion(IntPtr L)
    {
        try
        {
            ToLua.Push(L, CLASSTAG_GameVersion.frameworkVersion);
            ToLua.Push(L, CLASSTAG_GameVersion.dllVersion);
            ToLua.Push(L, CLASSTAG_GameVersion.resVersion);
            ToLua.Push(L, CLASSTAG_GameVersion.svnVersion);
            return 4;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }


    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_SetClipBoardText(IntPtr L)
    {
        try
        {
            string text = ToLua.CheckString(L, 1);
            PlatformAPI.SetClipBoardText(text);
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_GetClipBoardText(IntPtr L)
    {
        try
        {
            string text = PlatformAPI.GetClipBoardText();
            ToLua.Push(L, text);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_ReleaseCSharpObjects(IntPtr L)
    {
        try
        {
            ObjectTranslator translator = ObjectTranslator.Get(L);
            LuaDLL.lua_pushnil(L);
            while (LuaDLL.lua_next(L, 1) != 0)
            {
                int udata = LuaDLL.tolua_rawnetobj(L, -1);
                LuaDLL.lua_pop(L, 1);
                translator.Destroy(udata);
            }
            //translator.Destroy(udata);

            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_SetGlobalEventHanlder(IntPtr L)
    {
        try
        {
            LuaFunction calback = ToLua.CheckLuaFunction(L, 1);
            if(GlobalEventHanlder.luaGlobalCallback != null)
            {
                GlobalEventHanlder.luaGlobalCallback.Dispose();
            }
            GlobalEventHanlder.luaGlobalCallback = calback;
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }


    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_SetLogLevel(IntPtr L)
    {
        try
        {
            int level = LuaDLL.lua_tointeger(L, 1);
            GameDebug.SetLogLevel(level);
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }


    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_DumpLuaDataFile(IntPtr L)
    {
        try
        {
            CLASSTAG_LuaZip.FUNCTAG_DumpAllFile();
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_Vibrate(IntPtr L)
    {
        try
        {
#if UNITY_ANDROID || UNITY_IOS 
            Handheld.Vibrate();
#endif
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_LogError(IntPtr L)
    {
        try
        {
            string msg = ToLua.CheckString(L, 1);
            GameDebug.LogError(msg);
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_LogLuaError(IntPtr L)
	{
		try
		{
			string msg = ToLua.CheckString(L, 1);
			string stackTrace = ToLua.CheckString(L, 2);
			GameDebug.LogLuaError(msg, stackTrace);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_LogLuaException(IntPtr L)
	{
		try
		{
			string msg = ToLua.CheckString(L, 1);
			GameDebug.LogLuaException(msg);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_GetCenterServerUrl(IntPtr L)
    {
        try
        {
			var url = AssetUpdate.Instance.GetCenterServerUrl();
			ToLua.Push(L, url);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }


	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_GetGameSettingText(IntPtr L)
	{
		try
		{
			var s = CLASSTAG_GameSetting.GetGameSettingJson();
			ToLua.Push(L, s);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_SetTcpParerXorKey(IntPtr L)
    {
        try
        {
			string key = ToLua.CheckString(L, 1);
			TcpParser.SetXorKey(key);
			return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

	
	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_GetUpdateMode(IntPtr L)
    {
        try
        {
			ToLua.Push(L, CLASSTAG_GameSetting.updateMode);
			return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_SetSoftInputShowCallback(IntPtr L)
    {
        try
        {
            LuaFunction func = ToLua.CheckLuaFunction(L, 1);
            UnityEditDialog.FUNCTAG_SetSoftInputShowCallback(func);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }
    
    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_SetSoftInputHideCallback(IntPtr L)
    {
        try
        {
            LuaFunction func = ToLua.CheckLuaFunction(L, 1);
            UnityEditDialog.FUNCTAG_SetSoftInputHideCallback(func);
            return 1;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_RenderAddMat(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			var rend = ToLua.CheckUnityObject(L, 1, typeof(Renderer)) as Renderer;
			var mat = ToLua.CheckUnityObject(L, 2, typeof(Material)) as Material;
			Utils.FUNCTAG_RenderAddMat(rend, mat);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_RenderResizeMatCnt(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			var rend = ToLua.CheckUnityObject(L, 1, typeof(Renderer)) as Renderer;
			var cnt = LuaDLL.lua_tointeger(L, 2);
			Utils.FUNCTAG_RenderResizeMatCnt(rend, cnt);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_GetMaterials(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			var table = ToLua.ToLuaTable(L, 1);
			var list = Utils.FUNCTAG_GetMaterials(table.ToArray());
			var array = list.ToArray();
			LuaDLL.lua_newtable(L);
			int top = LuaDLL.lua_gettop(L);
			for (int i = 0; i < array.Length; i++)
			{
				ToLua.Push(L, i + 1);
				ToLua.Push(L, array[i]);
				LuaDLL.lua_settable(L, -3);
			}
			LuaDLL.lua_settop(L, top);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_RestoreGameRes(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			var restart = LuaDLL.lua_toboolean(L, 1);
			Utils.FUNCTAG_RestoreGameRes(restart);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

    [MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
    static int FUNCTAG_SetCrashAppVersion(IntPtr L)
    {
        try
        {
            string version = ToLua.CheckString(L, 1);
            //Crasheye.SetAppVersion(version);
            return 0;
        }
        catch (Exception e)
        {
            return LuaDLL.toluaL_exception(L, e);
        }
    }

}

